﻿using NUnit.Framework;
using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;
using OpenQA.Selenium.Support.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HelloSelenium
{
    public class DemoQARegistrateUser
    {
        private IWebDriver driver;

        [SetUp]
        public void TestInitialize()
        {
            this.driver = new ChromeDriver();
        }

        [Test]
        public void RegitrateUserWithFullData()
        {
            driver.Navigate().GoToUrl("http://demoqa.com/");
            driver.Manage().Window.Maximize();
            IWebElement registartionButton = driver.FindElement(By.XPath("//*[@id='menu-item-374']/a"));
            registartionButton.Click();
            IWebElement firstName = driver.FindElement(By.Id("name_3_firstname"));
            firstName.SendKeys("Ventsislav");
            IWebElement lastName = driver.FindElement(By.Id("name_3_lastname"));
            lastName.SendKeys("Ivanov");
            IList<IWebElement> martialStatus = driver.FindElements(By.Name("radio_4[]"));
            for (int i = 0; i < martialStatus.Count; i++)
            {
                martialStatus[1].Click();
            }
            IList<IWebElement> hobbys = driver.FindElements(By.Name("checkbox_5[]"));
            foreach (var hobby in hobbys)
            {
                hobby.Click();
            }
            IWebElement country = driver.FindElement(By.Id("dropdown_7"));
            SelectElement coutryOption = new SelectElement(country);
            coutryOption.SelectByText("Bulgaria");
            IWebElement birthMonth = driver.FindElement(By.Id("mm_date_8"));
            SelectElement birthMonthOption = new SelectElement(birthMonth);
            birthMonthOption.SelectByText("3");
            IWebElement birthDay = driver.FindElement(By.Id("dd_date_8"));
            SelectElement birthDayOption = new SelectElement(birthDay);
            birthDayOption.SelectByText("3");
            IWebElement birthYear = driver.FindElement(By.Id("yy_date_8"));
            SelectElement birthYearOption = new SelectElement(birthYear);
            birthYearOption.SelectByValue("2000");
            IWebElement phone = driver.FindElement(By.Id("phone_9"));
            phone.SendKeys("8888888888");
            IWebElement userName = driver.FindElement(By.Id("username"));
            userName.SendKeys("tutytdycfcgfc");
            IWebElement email = driver.FindElement(By.Id("email_1"));
            email.SendKeys("uigyfhgfyh@fhdf.bg");
            IWebElement picButton = driver.FindElement(By.Id("profile_pic_10"));
            picButton.Click();
            driver.SwitchTo().ActiveElement().SendKeys(@"C:\Users\Buro\Desktop\Seminar\Pics\enviroment.jpg");
            IWebElement description = driver.FindElement(By.Id("description"));
            description.SendKeys("Web Testing");
            IWebElement password = driver.FindElement(By.Id("password_2"));
            password.SendKeys("12345678");
            IWebElement passwordConfirm = driver.FindElement(By.Id("confirm_password_password_2"));
            passwordConfirm.SendKeys("12345678");
            IWebElement submit = driver.FindElement(By.XPath("//*[@id='pie_register']/li[14]/div/input"));
            submit.Click();
            IWebElement completeMessage = driver.FindElement(By.XPath("//*[@id='post-49']/div/p"));
            Assert.AreEqual("Thank you for your registration", completeMessage.Text);
        }

        [TearDown]
        public void EndTest()
        {
            driver.Quit();
        }
    }
}
