﻿using OpenQA.Selenium;
using OpenQA.Selenium.Support.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WebDriverDemo.Models;
using WebDriverDemo.Pages;

namespace WebDriverDemo.Facades
{
    public class RegistrationFacade
    {
        public void RegistrateUser(RegistrationPage registrationPage, RegistrationUser user, IWebDriver driver)
        {
            registrationPage.Navigate();
            registrationPage.FirstName.SendKeys(user.FirstName);
            registrationPage.LastName.SendKeys(user.LastName);
            registrationPage.MatrialStatus.Click();
            registrationPage.FillHobbys(new List<bool>());
            registrationPage.CountryOptions.SelectByText(user.Country);
            registrationPage.MonthOptions.SelectByText(user.BirthMonth);
            registrationPage.DateOptions.SelectByText(user.BirthDay);
            registrationPage.YearOptions.SelectByValue(user.BirthYear);
            registrationPage.Phone.SendKeys(user.Phone);
            registrationPage.UserNmae.SendKeys(user.UserName);
            registrationPage.Email.SendKeys(user.Email);
            registrationPage.UploadButton.Click();
            driver.SwitchTo().ActiveElement().SendKeys(user.Picture);
            registrationPage.Description.SendKeys(user.Description);
            registrationPage.Password.SendKeys(user.Password);
            registrationPage.ConfirmPassword.SendKeys(user.ConfirmPassword);
            registrationPage.SubmitButton.Click();
            WebDriverWait wait = new WebDriverWait(driver, TimeSpan.FromSeconds(15));
            Func<IWebDriver, bool> waitForElement = new Func<IWebDriver, bool>((IWebDriver Web) =>
            {
                if (registrationPage.NamesErrorMessage.Displayed)
                {
                    return true;
                }
                return false;
            });
            wait.Until(waitForElement);
        }
    }
}
