﻿using OpenQA.Selenium;
using OpenQA.Selenium.Support.PageObjects;
using OpenQA.Selenium.Support.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WebDriverDemo.Pages
{
    public class RegistrationPage
    {
        private IWebDriver driver;

        [FindsBy(How = How.TagName, Using = "title")]
        [CacheLookup]
        public IWebElement Title { get; }

        [FindsBy(How = How.Id, Using = "name_3_firstname")]
        [CacheLookup]
        public IWebElement FirstName { get; }

        [FindsBy(How = How.Id, Using = "name_3_lastname")]
        [CacheLookup]
        public IWebElement LastName { get; }

        [FindsBy(How = How.XPath, Using = "//*[@id='pie_register']/li[1]/div[1]/div[2]/span")]
        public IWebElement NamesErrorMessage { get; }

        [FindsBy(How = How.XPath, Using = "//*[@id='pie_register']/li[2]/div/div/input[1]")]
        [CacheLookup]
        public IWebElement MatrialStatus { get; }

        [FindsBy(How = How.Name, Using = "checkbox_5")]
        [CacheLookup]
        public IList<IWebElement> Hobbys { get; }

        [FindsBy(How = How.Id, Using = "dropdown_7")]
        [CacheLookup]
        public IWebElement Country { get; }

        public SelectElement CountryOptions 
        { 
            get
            {
                return new SelectElement(this.Country);
            }
        }

        [FindsBy(How = How.Id, Using = "mm_date_8")]
        [CacheLookup]
        public IWebElement BirthMonth { get; }

        public SelectElement MonthOptions
        {
            get
            {
                return new SelectElement(this.BirthMonth);
            }
        }

        [FindsBy(How = How.Id, Using = "dd_date_8")]
        [CacheLookup]
        public IWebElement BirthDate { get; }

        public SelectElement DateOptions
        {
            get
            {
                return new SelectElement(this.BirthDate);
            }
        }

        [FindsBy(How = How.Id, Using = "yy_date_8")]
        [CacheLookup]
        public IWebElement BirthYear { get; }

        public SelectElement YearOptions
        {
            get
            {
                return new SelectElement(this.BirthYear);
            }
        }

        [FindsBy(How = How.Id, Using = "phone_9")]
        [CacheLookup]
        public IWebElement Phone { get; }

        [FindsBy(How = How.Id, Using = "username")]
        [CacheLookup]
        public IWebElement UserNmae { get; }

        [FindsBy(How = How.Id, Using = "email_1")]
        [CacheLookup]
        public IWebElement Email { get; }

        [FindsBy(How = How.Id, Using = "profile_pic_10")]
        [CacheLookup]
        public IWebElement UploadButton { get; }

        [FindsBy(How = How.Id, Using = "description")]
        [CacheLookup]
        public IWebElement Description { get; }

        [FindsBy(How = How.Id, Using = "password_2")]
        [CacheLookup]
        public IWebElement Password { get; }

        [FindsBy(How = How.Id, Using = "confirm_password_password_2")]
        [CacheLookup]
        public IWebElement ConfirmPassword { get; }

        [FindsBy(How = How.XPath, Using = "//*[@id='pie_register']/li[14]/div/input")]
        [CacheLookup]
        public IWebElement SubmitButton { get; }

        [FindsBy(How = How.ClassName, Using = "piereg_message")]
        public IWebElement RegistrationCompleteMessage { get; }

        public void FillHobbys(List<bool> hobbys)
        {
            for (int i = 0; i < hobbys.Count - 1; i++)
            {
                if(!hobbys[i])
                {
                    this.Hobbys[i].Click();
                }
            }
        }

        public void Navigate()
        {
            driver.Navigate().GoToUrl(@"http://demoqa.com/registration/");
            driver.Manage().Window.Maximize();
        }
    }
}
